Index: sandbox/MultiChannelUSB/UserInterface.tcl
===================================================================
--- sandbox/MultiChannelUSB/UserInterface.tcl	(revision 106)
+++ sandbox/MultiChannelUSB/UserInterface.tcl	(revision 143)
@@ -223,448 +692,135 @@
 # -------------------------------------------------------------------------
 
-    OscDisplay instproc reset {} {
-        my instvar data xvec yvec
-
-        set data {}
-
-        $yvec set {}
-    }
-
-# -------------------------------------------------------------------------
-
-    OscDisplay instproc start {} {
-        my instvar config trig_mux disp_mux
-
-        set trig_mux 2
-        set disp_mux 2
+    HstDisplay instproc start {} {
+        my instvar config
 
         trace add variable [myvar data] write [myproc data_update]
-        trace add variable [myvar auto] write [myproc auto_update]
+        trace add variable [myvar cntr_val] write [myproc cntr_val_update]
+        trace add variable [myvar rate_val] write [myproc rate_val_update]
+
+        trace add variable [myvar axis] write [myproc axis_update]
         trace add variable [myvar thrs] write [myproc thrs_update]
-        trace add variable [myvar thrs_val] write [myproc thrs_val_update]
-        trace add variable [myvar disp_val] write [myproc disp_val_update]
-        trace add variable [myvar trig_val] write [myproc trig_val_update]
-
-        ${config}.auto_check select
+        trace add variable [myvar thrs_val] write [myproc thrs_update]
+        trace add variable [myvar base] write [myproc base_update]
+        trace add variable [myvar base_typ] write [myproc base_typ_update]
+        trace add variable [myvar base_val] write [myproc base_val_update]
+
+        ${config}.axis_check select
+
         ${config}.thrs_check select
-        ${config}.thrs_field set 1278
-        ${config}.disp_uwt2 select
-        ${config}.trig_uwt2 select
-    }
-
-# -------------------------------------------------------------------------
-
-    OscDisplay instproc setup {} {
+        ${config}.thrs_field set 25
+
+        ${config}.base_auto select
+        ${config}.base_field set 20
+        ${config}.base_check select
+
+        set cntr_tmp 1200000000
+        my set cntr_val $cntr_tmp
+        my set cntr_bak $cntr_tmp
+        my set cntr_old $cntr_tmp
+        my set yvec_bak 0.0
+        my set yvec_old 0.0
+
+        my set rate_val(inst) 0.0
+        my set rate_val(mean) 0.0
+
+#        my cntr_reset
+    }
+
+# -------------------------------------------------------------------------
+
+    HstDisplay instproc setup {} {
         my instvar number master
-        my instvar data xvec yvec
-        my instvar config auto thrs thrs_val disp_val trig_val
+        my instvar xvec yvec graph
+        my instvar config thrs thrs_val base base_typ base_val
+        my instvar cntr_h cntr_m cntr_s
 
         # create a graph widget and show a grid
         set graph [graph ${master}.graph -height 250 -leftmargin 80]
-        $graph crosshairs configure -hide no -linewidth 2 -dashes { 1 1 }
+        $graph crosshairs configure -hide no -linewidth 1 -color darkblue -dashes {2 2}
         $graph grid configure -hide no
         $graph legend configure -hide yes
-        $graph axis configure x -min 0 -max 1024
-        $graph axis configure y -min 0 -max 4100
-
-        set config [frame ${master}.config]
-
-        checkbutton ${config}.auto_check -text {auto update} -variable [myvar auto]
-
-        frame ${config}.spc1 -width 10 -height 10
+        $graph axis configure x -min 0 -max 4096
+
+        set config [frame ${master}.config -width 170]
+
+        checkbutton ${config}.axis_check -text {log scale} -variable [myvar axis]
+
+        frame ${config}.spc1 -width 170 -height 30
+
+        frame ${config}.rate_frame -borderwidth 0 -width 170
+        legendLabel ${config}.rate_frame 0 inst {Inst. rate, 1/s}
+        legendLabel ${config}.rate_frame 1 mean {Avg. rate, 1/s}
+
+        frame ${config}.spc2 -width 170 -height 30
+
+        frame ${config}.chan_frame -borderwidth 0 -width 170
+        legendLabel ${config}.chan_frame 0 axisy {Bin entries}
+        legendLabel ${config}.chan_frame 1 axisx {Bin number}
+
+        frame ${config}.spc3 -width 170 -height 30
+
+        frame ${config}.cntr_frame -borderwidth 0 -width 170
+
+        label ${config}.cntr_frame.h -width 3 -anchor w -text {h}
+        entry ${config}.cntr_frame.h_field -width 3 -textvariable [myvar cntr_h] \
+            -validate all -vcmd {::mca::validate 999 3 %P}
+        label ${config}.cntr_frame.m -width 3 -anchor w -text {m}
+        entry ${config}.cntr_frame.m_field -width 3 -textvariable [myvar cntr_m] \
+            -validate all -vcmd {::mca::validate 59 2 %P}
+        label ${config}.cntr_frame.s -width 3 -anchor w -text {s}
+        entry ${config}.cntr_frame.s_field -width 6 -textvariable [myvar cntr_s] \
+            -validate all -vcmd {::mca::doublevalidate 59.999 %P}
+
+        grid ${config}.cntr_frame.h_field ${config}.cntr_frame.h \
+            ${config}.cntr_frame.m_field ${config}.cntr_frame.m ${config}.cntr_frame.s_field ${config}.cntr_frame.s
+
+        frame ${config}.spc4 -width 170 -height 10
+
+        button ${config}.start -text Start \
+            -bg yellow -activebackground yellow -command [myproc cntr_start]
+        button ${config}.reset -text Reset \
+            -bg red -activebackground red -command [myproc cntr_reset]
+
+        frame ${config}.spc5 -width 170 -height 30
 
         checkbutton ${config}.thrs_check -text threshold -variable [myvar thrs]
         spinbox ${config}.thrs_field -from 1 -to 4095 \
             -increment 5 -width 10 -textvariable [myvar thrs_val] \
-            -validate all -vcmd {::mca::validate 4095 %P}
-
-        frame ${config}.spc2 -width 10 -height 10
-
-        label ${config}.disp -text {display input}
-        radiobutton ${config}.disp_data -text {raw data} -variable [myvar disp_val] -value data
-        radiobutton ${config}.disp_uwt1 -text {filter 1} -variable [myvar disp_val] -value uwt1
-        radiobutton ${config}.disp_uwt2 -text {filter 2} -variable [myvar disp_val] -value uwt2
-        radiobutton ${config}.disp_uwt3 -text {filter 3} -variable [myvar disp_val] -value uwt3
-        radiobutton ${config}.disp_base -text {baseline} -variable [myvar disp_val] -value base
-#        radiobutton ${config}.disp_sum8 -text {sum of 8} -variable [myvar disp_val] -value sum8
-
-        frame ${config}.spc3 -width 10 -height 10
-
-        label ${config}.trig -text {trigger input}
-        radiobutton ${config}.trig_data -text {raw data} -variable [myvar trig_val] -value data
-        radiobutton ${config}.trig_uwt1 -text {filter 1} -variable [myvar trig_val] -value uwt1
-        radiobutton ${config}.trig_uwt2 -text {filter 2} -variable [myvar trig_val] -value uwt2
-        radiobutton ${config}.trig_uwt3 -text {filter 3} -variable [myvar trig_val] -value uwt3
-        radiobutton ${config}.trig_base -text {baseline} -variable [myvar trig_val] -value base
-#        radiobutton ${config}.trig_sum8 -text {sum of 8} -variable [myvar trig_val] -value sum8
-
-        frame ${config}.spc4 -width 10 -height 10
-
-        button ${config}.acquire -text Acquire \
-            -bg green -activebackground green -command [myproc acquire]
-        button ${config}.restart -text Restart \
-            -bg yellow -activebackground yellow -command [myproc restart]
+            -validate all -vcmd {::mca::validate 4095 4 %P}
+
+        frame ${config}.spc6 -width 170 -height 30
+
+        checkbutton ${config}.base_check -text baseline -variable [myvar base]
+        radiobutton ${config}.base_auto -text automatic -variable [myvar base_typ] -value 1
+        radiobutton ${config}.base_const -text constant -variable [myvar base_typ] -value 0
+        spinbox ${config}.base_field -from 1 -to 4095 \
+            -increment 5 -width 10 -textvariable [myvar base_val] \
+            -validate all -vcmd {::mca::validate 4095 4 %P}
+
+        frame ${config}.spc7 -width 170 -height 30
+
         button ${config}.register -text Register \
             -bg lightblue -activebackground lightblue -command [myproc register]
 
-        grid ${config}.auto_check -sticky w
+        grid ${config}.axis_check -sticky w
         grid ${config}.spc1
+        grid ${config}.rate_frame -sticky ew -padx 5
+        grid ${config}.spc2
+        grid ${config}.chan_frame -sticky ew -padx 5
+        grid ${config}.spc3
+        grid ${config}.cntr_frame -sticky ew -padx 5
+        grid ${config}.spc4
+        grid ${config}.start -sticky ew -pady 3 -padx 5
+        grid ${config}.reset -sticky ew -pady 3 -padx 5
+        grid ${config}.spc5
         grid ${config}.thrs_check -sticky w
         grid ${config}.thrs_field -sticky ew -pady 1 -padx 5
-        grid ${config}.spc2
-        grid ${config}.disp -sticky w -pady 1 -padx 3
-        grid ${config}.disp_data -sticky w
-        grid ${config}.disp_uwt1 -sticky w
-        grid ${config}.disp_uwt2 -sticky w
-        grid ${config}.disp_uwt3 -sticky w
-        grid ${config}.disp_base -sticky w
-#        grid ${config}.disp_sum8 -sticky w
-        grid ${config}.spc3
-        grid ${config}.trig -sticky w -pady 1 -padx 3
-        grid ${config}.trig_data -sticky w
-        grid ${config}.trig_uwt1 -sticky w
-        grid ${config}.trig_uwt2 -sticky w
-        grid ${config}.trig_uwt3 -sticky w
-        grid ${config}.trig_base -sticky w
-#        grid ${config}.disp_sum8 -sticky w
-        grid ${config}.spc4
-        grid ${config}.acquire -sticky ew -pady 3 -padx 5
-        grid ${config}.restart -sticky ew -pady 3 -padx 5
-        grid ${config}.register -sticky ew -pady 3 -padx 5
-
-        grid ${graph} -row 0 -column 0 -sticky news
-        grid ${config} -row 0 -column 1
-
-        grid rowconfigure ${master} 0 -weight 1
-        grid columnconfigure ${master} 0 -weight 1
-        grid columnconfigure ${master} 1 -weight 0 -minsize 80
-
-        # enable zooming
-        Blt_ZoomStack $graph
-
-        #bind .graph <Motion> {%W crosshairs configure -position @%x,%y}
-
-        # create one element with data for the x and y axis, no dots
-        $graph element create Spectrum1 -symbol none -xdata $xvec -ydata $yvec
-    }
-
-# -------------------------------------------------------------------------
-
-    OscDisplay instproc data_update args {
-        my instvar data yvec
-        $yvec set $data
-    }
-
-# -------------------------------------------------------------------------
-
-    OscDisplay instproc auto_update args {
-        my instvar config auto after_handle
-
-        if {$auto} {
-            ${config}.acquire configure -state disabled
-            ${config}.restart configure -state disabled
-            ${config}.register configure -state disabled
-
-            my acquire_restart_loop
-        } else {
-            if {[my exists after_handle]} {
-                after cancel $after_handle
-            }
-            ${config}.acquire configure -state active
-            ${config}.restart configure -state active
-            ${config}.register configure -state active
-        }
-    }
-
-# -------------------------------------------------------------------------
-
-    OscDisplay instproc thrs_update args {
-        my instvar config number thrs thrs_val
-
-        set val_addr [format %04x [expr {17 + ${number}}]]
-
-        if {$thrs} {
-            ${config}.thrs_field configure -state normal
-            my thrs_val_update
-        } else {
-            ${config}.thrs_field configure -state disabled
-            my usbCmd ${val_addr}0000
-        }
-    }
-
-# -------------------------------------------------------------------------
-
-    OscDisplay instproc thrs_val_update args {
-        my instvar config number thrs_val
-
-        if {[string equal $thrs_val {}]} {
-            set thrs_val 0
-        }
-
-        set val_addr [format %04x [expr {17 + ${number}}]]
-        set value [format %04x $thrs_val]
-
-        my usbCmd ${val_addr}${value}
-    }
-
-# -------------------------------------------------------------------------
-
-    OscDisplay instproc mux {} {
-        my instvar trig_mux disp_mux
-
-        format {00%x%x} $trig_mux $disp_mux
-    }
-
-# ------------------------------------------------------------------------
-
-    OscDisplay instproc disp_val_update args {
-        my instvar number disp_val disp_mux
-
-        set mux_addr [format %04x [expr {20 + ${number}}]]
-
-        switch -- $disp_val {
-            data {
-                set disp_mux 0
-                my usbCmd ${mux_addr}[my mux]
-            }
-            uwt1 {
-                set disp_mux 1
-                my usbCmd ${mux_addr}[my mux]
-            }
-            uwt2 {
-                set disp_mux 2
-                my usbCmd ${mux_addr}[my mux]
-            }
-            uwt3 {
-                set disp_mux 3
-                my usbCmd ${mux_addr}[my mux]
-            }
-            base {
-                set disp_mux 4
-                my usbCmd ${mux_addr}[my mux]
-            }
-        }
-    }
-
-# ------------------------------------------------------------------------
-
-    OscDisplay instproc trig_val_update args {
-        my instvar number trig_val trig_mux
-
-        set mux_addr [format %04x [expr {20 + ${number}}]]
-
-        switch -- $trig_val {
-            data {
-                set trig_mux 0
-                my usbCmd ${mux_addr}[my mux]
-            }
-            uwt1 {
-                set trig_mux 1
-                my usbCmd ${mux_addr}[my mux]
-            }
-            uwt2 {
-                set trig_mux 2
-                my usbCmd ${mux_addr}[my mux]
-            }
-            uwt3 {
-                set trig_mux 3
-                my usbCmd ${mux_addr}[my mux]
-            }
-            base {
-                set trig_mux 4
-                my usbCmd ${mux_addr}[my mux]
-            }
-        }
-    }
-
-# -------------------------------------------------------------------------
-
-    OscDisplay instproc save_data {data} {
-        set file [tk_getSaveFile]
-        if {[string equal $file {}]} {
-            return
-        }
-
-        set x [catch {set fid [open $file w+]}]
-        set y [catch {puts $fid $data}]
-        set z [catch {close $fid}]
-
-        if { $x || $y || $z || ![file exists $file] || ![file isfile $file] || ![file readable $file] } {
-            tk_messageBox -icon error \
-                -message "An error occurred while writing to \"$file\""
-        } else {
-            tk_messageBox -icon info \
-                -message "File \"$file\" written successfully"
-        }
-    }
-
-# -------------------------------------------------------------------------
-
-    OscDisplay instproc acquire {} {
-        my instvar number
-        my usbCmdRead 0002000${number} 2 1024
-   }
-
-# -------------------------------------------------------------------------
-
-    OscDisplay instproc restart {} {
-        my instvar number
-        my usbCmd 0001000${number}
-    }
-
-# -------------------------------------------------------------------------
-
-    OscDisplay instproc register {} {
-        my save_data [my set data]
-    }
-
-# -------------------------------------------------------------------------
-
-    OscDisplay instproc acquire_restart_loop {} {
-        my instvar number after_handle
-
-        my acquire
-        my restart
-
-        set after_handle [after 1000 [myproc acquire_restart_loop]]
-    }
-
-# -------------------------------------------------------------------------
-
-    Class HstDisplay -superclass Display -parameter {
-        {number}
-        {master}
-    }
-
-# -------------------------------------------------------------------------
-
-    HstDisplay instproc init {} {
-        my instvar data xvec yvec
-
-        set xvec [vector #auto]
-        set yvec [vector #auto]
-        # fill one vector for the x axis with 4097 points
-        $xvec seq 0 4096
-
-        my reset
-
-        my setup
-
-        next
-    }
-
-# -------------------------------------------------------------------------
-
-    HstDisplay instproc destroy {} {
-        next
-    }
-
-# -------------------------------------------------------------------------
-
-    HstDisplay instproc reset {} {
-        my instvar data xvec yvec
-
-        set data {}
-
-        $yvec set {}
-    }
-
-# -------------------------------------------------------------------------
-
-    HstDisplay instproc start {} {
-        my instvar config base_mux peak_mux
-
-        set base_mux 0
-        set peak_mux 1
-
-        trace add variable [myvar axis] write [myproc axis_update]
-        trace add variable [myvar data] write [myproc data_update]
-        trace add variable [myvar auto] write [myproc auto_update]
-        trace add variable [myvar peak] write [myproc peak_update]
-        trace add variable [myvar thrs] write [myproc thrs_update]
-        trace add variable [myvar thrs_val] write [myproc thrs_val_update]
-        trace add variable [myvar base] write [myproc base_update]
-        trace add variable [myvar base_typ] write [myproc base_typ_update]
-        trace add variable [myvar base_val] write [myproc base_val_update]
-
-        ${config}.axis_check deselect
-        ${config}.auto_check select
-        ${config}.peak_check select
-
-        ${config}.thrs_check select
-        ${config}.thrs_field set 1278
-
-        ${config}.base_const select
-        ${config}.base_field set 35
-        ${config}.base_check deselect
-    }
-
-# -------------------------------------------------------------------------
-
-    HstDisplay instproc setup {} {
-        my instvar number master
-        my instvar data xvec yvec graph
-        my instvar config auto thrs thrs_val base base_typ base_val
-
-        # create a graph widget and show a grid
-        set graph [graph ${master}.graph -height 250 -leftmargin 80]
-        $graph crosshairs configure -hide no -linewidth 2 -dashes { 1 1 }
-        $graph grid configure -hide no
-        $graph legend configure -hide yes
-        $graph axis configure x -min 0 -max 4096
-
-        set config [frame ${master}.config]
-
-        checkbutton ${config}.axis_check -text {log scale} -variable [myvar axis]
-
-        frame ${config}.spc1 -width 10 -height 10
-
-        checkbutton ${config}.auto_check -text {auto update} -variable [myvar auto]
-
-        frame ${config}.spc2 -width 10 -height 10
-
-        checkbutton ${config}.peak_check -text {peak detect} -variable [myvar peak]
-
-        frame ${config}.spc3 -width 10 -height 10
-
-        checkbutton ${config}.thrs_check -text threshold -variable [myvar thrs]
-        spinbox ${config}.thrs_field -from 1 -to 4095 \
-            -increment 5 -width 10 -textvariable [myvar thrs_val] \
-            -validate all -vcmd {::mca::validate 4095 %P}
-
-        frame ${config}.spc4 -width 10 -height 10
-
-        checkbutton ${config}.base_check -text baseline -variable [myvar base]
-        radiobutton ${config}.base_auto -text automatic -variable [myvar base_typ] -value auto
-        radiobutton ${config}.base_const -text constant -variable [myvar base_typ] -value const
-        spinbox ${config}.base_field -from 1 -to 4095 \
-            -increment 5 -width 10 -textvariable [myvar base_val] \
-            -validate all -vcmd {::mca::validate 4095 %P}
-
-        frame ${config}.spc5 -width 10 -height 10
-
-        button ${config}.acquire -text Acquire \
-            -bg green -activebackground green -command [myproc acquire]
-        button ${config}.restart -text Restart \
-            -bg yellow -activebackground yellow -command [myproc restart]
-        button ${config}.register -text Register \
-            -bg lightblue -activebackground lightblue -command [myproc register]
-
-        grid ${config}.axis_check -sticky w
-        grid ${config}.spc1
-        grid ${config}.auto_check -sticky w
-        grid ${config}.spc2
-        grid ${config}.peak_check -sticky w
-        grid ${config}.spc3
-        grid ${config}.thrs_check -sticky w
-        grid ${config}.thrs_field -sticky ew -pady 1 -padx 5
-        grid ${config}.spc4
+        grid ${config}.spc6
         grid ${config}.base_check -sticky w
         grid ${config}.base_auto -sticky w
         grid ${config}.base_const -sticky w
         grid ${config}.base_field -sticky ew -pady 1 -padx 5
-        grid ${config}.spc5
-        grid ${config}.acquire -sticky ew -pady 3 -padx 5
-        grid ${config}.restart -sticky ew -pady 3 -padx 5
+        grid ${config}.spc7
         grid ${config}.register -sticky ew -pady 3 -padx 5
 
@@ -676,11 +832,43 @@
         grid columnconfigure ${master} 1 -weight 0 -minsize 80
 
+        grid columnconfigure ${config}.rate_frame 1 -weight 1
+        grid columnconfigure ${config}.chan_frame 1 -weight 1
+
         # enable zooming
         Blt_ZoomStack $graph
 
+        my crosshairs $graph
+
         #bind .graph <Motion> {%W crosshairs configure -position @%x,%y}
 
         # create one element with data for the x and y axis, no dots
-        $graph element create Spectrum1 -symbol none -smooth step -xdata $xvec -ydata $yvec
+        $graph element create Spectrum1 -color blue -linewidth 2 -symbol none -smooth step -xdata [myvar xvec] -ydata [myvar yvec]
+    }
+
+# -------------------------------------------------------------------------
+
+    HstDisplay instproc coor_update {W x y} {
+        my instvar config graph
+
+        $W crosshairs configure -position @${x},${y}
+
+        set index [$W axis invtransform x $x]
+        set index [::tcl::mathfunc::round $index]
+        catch {
+            ${config}.chan_frame.axisy_value configure -text [[myvar yvec] index $index]
+            ${config}.chan_frame.axisx_value configure -text ${index}.0
+        }
+    }
+# -------------------------------------------------------------------------
+
+    HstDisplay instproc crosshairs {graph} {
+        set method [myproc coor_update]
+        bind $graph <Motion> [list [self] coor_update %W %x %y]
+        bind $graph <Leave> {
+            %W crosshairs off
+        }
+        bind $graph <Enter> {
+            %W crosshairs on
+        }
     }
 
@@ -698,81 +886,22 @@
 # -------------------------------------------------------------------------
 
-    HstDisplay instproc data_update args {
-        my instvar data yvec
-        $yvec set $data
-    }
-
-# -------------------------------------------------------------------------
-
-    HstDisplay instproc auto_update args {
-        my instvar auto after_handle
-        my instvar config
-        if {$auto} {
-            ${config}.acquire configure -state disabled
-            ${config}.register configure -state disabled
-
-            my acquire_loop
-        } else {
-            if {[my exists after_handle]} {
-                after cancel $after_handle
-            }
-            ${config}.acquire configure -state active
-            ${config}.register configure -state active
-        }
-    }
-
-# -------------------------------------------------------------------------
-
-    HstDisplay instproc mux {} {
-        my instvar base_mux peak_mux
-
-        format {00%x%x} $base_mux $peak_mux
-    }
-
-# -------------------------------------------------------------------------
-
-    HstDisplay instproc peak_update args {
-        my instvar number peak peak_mux
-
-        set mux_addr [format %04x [expr {23 + ${number}}]]
-
-        if {$peak} {
-            set peak_mux 1
-            my usbCmd ${mux_addr}[my mux]
-        } else {
-            set peak_mux 0
-            my usbCmd ${mux_addr}[my mux]
-        }
-    }
-
-# -------------------------------------------------------------------------
-
     HstDisplay instproc thrs_update args {
-        my instvar config number thrs thrs_val
-
-        set val_addr [format %04x [expr {14 + ${number}}]]
+        my instvar controller config number thrs thrs_val
+
+        if {[string equal $thrs_val {}]} {
+            set thrs_val 0
+        }
+
+        set val_addr [format %02x [expr {6 + 2 * ${number}}]]
 
         if {$thrs} {
             ${config}.thrs_field configure -state normal
-            my thrs_val_update
+            set value [format %03x $thrs_val]
         } else {
             ${config}.thrs_field configure -state disabled
-            my usbCmd ${val_addr}0000
-        }
-    }
-
-# -------------------------------------------------------------------------
-
-    HstDisplay instproc thrs_val_update args {
-        my instvar config number thrs_val
-
-        if {[string equal $thrs_val {}]} {
-            set thrs_val 0
-        }
-
-        set val_addr [format %04x [expr {14 + ${number}}]]
-        set value [format %04x $thrs_val]
-
-        my usbCmd ${val_addr}${value}
+            set value 000
+        }
+
+        $controller usbCmd 000200${val_addr}00040${value}
     }
 
@@ -780,8 +909,7 @@
 
     HstDisplay instproc base_update args {
-        my instvar config number base base_val base_mux
-
-        set mux_addr [format %04x [expr {23 + ${number}}]]
-        set val_addr [format %04x [expr {11 + ${number}}]]
+        my instvar controller config number base base_typ
+
+        set val_addr [format %02x [expr {7 + 2 * ${number}}]]
 
         if {$base} {
@@ -793,6 +921,5 @@
             ${config}.base_const configure -state disabled
             ${config}.base_field configure -state disabled
-            set base_mux 0
-            my usbCmd ${mux_addr}[my mux]${val_addr}0000
+            $controller usbCmd 000200${val_addr}0004${base_typ}000
         }
     }
@@ -801,22 +928,16 @@
 
     HstDisplay instproc base_typ_update args {
-        my instvar config number base_typ base_val base_mux
-
-        set mux_addr [format %04x [expr {23 + ${number}}]]
-        set val_addr [format %04x [expr {11 + ${number}}]]
-        set value [format %04x $base_val]
+        my instvar config base_typ
 
         switch -- $base_typ {
-            auto {
+            1 {
                 ${config}.base_field configure -state disabled
-                set base_mux 1
-                my usbCmd ${mux_addr}[my mux]
             }
-            const {
+            0 {
                 ${config}.base_field configure -state normal
-                set base_mux 0
-                my usbCmd ${mux_addr}[my mux]${val_addr}${value}
             }
         }
+
+        my base_val_update
     }
 
@@ -824,5 +945,5 @@
 
     HstDisplay instproc base_val_update args {
-        my instvar number base_val
+        my instvar controller number base_typ base_val
 
         if {[string equal $base_val {}]} {
